import { createContext } from "react";
import "./App.css";
import ChildA from "./components/ChildA";

// what is useContext hook?
// create, provider, useContext
// allows the component to access some global data and re-render when that global data is changed.
// solves props drilling problem when we pass down props from parents to children.

// how to use it?
const titleContext = createContext();
const nameContext = createContext();
const genreContext = createContext();

function App() {
  const title = "useContext hook in reactjs";
  const name = "javacodegeeks";
  const genre = "learning";

  return (
    <div className="App">
      <titleContext.Provider value={title}>
        <nameContext.Provider value={name}>
          <genreContext.Provider value={genre}>
            <ChildA></ChildA>
          </genreContext.Provider>
        </nameContext.Provider>
      </titleContext.Provider>
    </div>
  );
}

export default App;
export { titleContext, nameContext, genreContext };
